/*
 * globals.c
 *
 * Definitions of global constants:  values set in Read_input or main 
 *    and never changed.
 */
#include "globals.h"
#include "utility.h"
#include "mpi.h"
#include "equations.h"

int my_rank;
int num_processes;
MPI_Comm comm;

int num_steps;
int num_my_equations;
int my_first_var;
int my_last_var;
int total_equations;  /* total number of variables 
                           - number of synaptic variables */
int num_my_neurons;
int my_first_neuron;
int my_last_neuron;
int total_neurons;
int row_count;
int col_count;

double time_init;
double step_size;

int print_freq;
char output_filename[MAX_NAME];

int* neuron_types;
syn_conn_t* syn_connections;
